Prevent focus on first element in EJ2 JavaScript Dialog control

30 Aug 20254 minutes to read

By default, the dialog focuses on the first elements of the content area which can be active and focusable. You can prevent this default focusing behavior using the open event and by enabling the preventFocus argument.

Bind the open event and enable the preventFocus argument within an event like the below sample.

ej.base.enableRipple(true);

// Initialization of Dialog component
var dialog = new ej.popups.Dialog({
    header: "Sign In",
    buttons: [{ buttonModel: { isPrimary: true, content: 'Yes' }, click: btnClick }, { buttonModel: { content: 'No'}, click: btnClick }],
    target: document.getElementById("container"),
    height: 'auto',
    width: '300px',
    open: onOpen
});
// Render initialized Dialog
dialog.appendTo('#dialog');

// Sample level code to handle the button click action
document.getElementById('targetButton').onclick = function () {
    // Call the show method to open the Dialog
    dialog.show();
};

function btnClick() {
    dialog.hide();
}

function onOpen(args: OpenEventArgs) {
  //Preventing the default dialog focus
  args.preventFocus = true;
}
<!DOCTYPE html><html lang="en"><head>
    <title>Essential JS 2 Dialog with header</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="TypeScript UI Components">
    <meta name="author" content="Syncfusion">
    <link href="styles.css" rel="stylesheet">
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/31.1.17/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/31.1.17/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/31.1.17/ej2-inputs/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/31.1.17/ej2-popups/styles/material.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/31.1.17/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <button class="e-control e-btn" id="targetButton" role="button" e-ripple="true" style="position: absolute;">Open Dialog</button>
        <div id="dialog">
            <div class="form-group"><label for="email">Email:</label>
                <input type="email" class="form-control" id="email">
            </div>
            <div class="form-group">
                <label for="comment">Password:</label>
                <input type="password" class="form-control" id="password">
            </div>
        </div>
    </div>

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

See Also

Prevent focus on the first element in Angular Dialog component

30 Aug 20254 minutes to read

By default, the dialog focuses on the first elements of the content area which can be active and focusable. You can prevent this default focusing behavior using the open event and by enabling the preventFocus argument.

Bind the open event and enable the preventFocus argument within an event like the below sample.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { DialogModule } from '@syncfusion/ej2-angular-popups'




import { Component, ViewChild, OnInit, ElementRef } from '@angular/core';
import { DialogComponent } from '@syncfusion/ej2-angular-popups';
import { EmitType } from '@syncfusion/ej2-base';

@Component({
imports: [
        
		DialogModule
    ],


standalone: true,
    selector: 'app-root',
    template: `
    <button class="e-control e-btn" style="position: absolute;" id="targetButton" (click)="onOpenDialog($event)">Open Dialog</button>
    <div #container class='root-container'></div>
    <ejs-dialog id='dialog' #ejDialog header='Sign In' [buttons]='buttons' [target]='targetElement' width='300px' (open)="onOpen($event)">
        <ng-template #content>
            <div class='form-group'><label for='email'>Email:</label>
                <input type='email' class='form-control' id='email'>
            </div>
            <div class='form-group'>
                <label for='comment'>Password:</label>
                <input type='password' class='form-control' id='password'>
            </div>
        </ng-template>
    </ejs-dialog>`
})

export class AppComponent implements OnInit {
  @ViewChild('ejDialog') ejDialog: DialogComponent | undefined;
  // Create element reference for dialog target element.
  @ViewChild('container', { read: ElementRef }) container: ElementRef | undefined;
  // The Dialog shows within the target element.
  public targetElement?: HTMLElement;

  // To get all element of the dialog component after component get initialized.
  ngOnInit() {
    this.initilaizeTarget();
  }

  // Initialize the Dialog component target element.
  public initilaizeTarget: EmitType<object> = () => {
    this.targetElement = this.container!.nativeElement.parentElement;
  }
  // Sample level code to handle the button click action
  public onOpenDialog = (event: any): void => {
    // Call the show method to open the Dialog
    this.ejDialog!.show();
  };

  public onOpen(args: any): void {
    //Preventing the default dialog focus
    args.preventFocus = true;
  }
    // Hide the Dialog when click the footer button.
    public hideDialog: EmitType<object> = () => {
      this.ejDialog!.hide();
  }

  // Enables the footer buttons
  public buttons: Object = [
    {
      'click': this.hideDialog.bind(this),
      // Accessing button component properties by buttonModel property
        buttonModel:{
        content: 'OK',
        // Enables the primary button
        isPrimary: true
      }
    },
    {
      'click': this.hideDialog.bind(this),
      buttonModel: {
        content: 'Cancel'
      }
    }
  ];


}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

See Also

HelpBot Assistant

How can I help you?

Prevent focus on first element in React Dialog component

20 Feb 202614 minutes to read

By default, when the dialog opens, focus is automatically set to the first focusable element in the content area. You can prevent this default behavior using the open event and setting the preventFocus argument to true.

Bind the open event and enable the preventFocus argument as shown in the following sample.

[Class-component]

import { DialogComponent } from '@syncfusion/ej2-react-popups';
import * as React from "react";
class App extends React.Component {
    dialogInstance;
    buttons = [{
            buttonModel: {
                content: 'Ok',
                isPrimary: true,
            },
            'click': () => {
                this.dialogInstance.hide();
            }
        }, {
            buttonModel: {
                content: 'Cancel'
            },
            'click': () => {
                this.dialogInstance.hide();
            }
        }];
    dialogContent() {
        return (<div className='form-group'><label htmlFor='email'>Email:</label>
            <input type='email' className='form-control' id='email'/>
        </div>
            ,
                <div className='form-group'>
            <label htmlFor='comment'>Password:</label>
            <input type='password' className='form-control' id='password'/>
        </div>);
    }
    onOpen = (args) => {
        args.preventFocus = true;
    };
    render() {
        return (<div className="App" id='container'>  
        <DialogComponent id="dlg-focus" width='300px' isModal={true} target='#container' header='Sign In' open={this.onOpen} buttons={this.buttons} ref={dialog => this.dialogInstance = dialog}>
         <div>{this.dialogContent()}</div>
         </DialogComponent>
    </div>);
    }
}
export default App;
import { DialogComponent } from '@syncfusion/ej2-react-popups';
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';
import * as React from "react";

class App extends React.Component<{}, {}> {
  public dialogObj: DialogComponent;
  private buttonRef;
  private buttonElement: HTMLElement | null;
  constructor(props: {}) {
    super(props);
    this.buttonElement = null;
    this.buttonRef = element => {
        this.buttonElement = element;
    };
  }
  public buttons: any = [{
    buttonModel: {
        content: 'Ok',
        isPrimary: true,
    },
    'click': () => {
        this.dialogObj.hide();
    }
  }, {
    buttonModel: {
        content: 'Cancel'
    },
    'click': () => {
        this.dialogObj.hide();
    }
  }];

  
  public onOpen = (args: any): void =>{
      args.preventFocus = true;
  }
  public onOpenDialog = function(): void {
    // Call the show method to open the Dialog
     this.dialogObj.show();
     this.buttonElement.style.display='none';
  };

  public onClose= function():void{
    this.buttonElement.style.display='block';
  }
  
  public render() {
    return (
    <div className="App" id='container'>
        <button className="e-control e-btn" style= ref={this.buttonRef} onClick={this.onOpenDialog.bind(this)}>Open dialog</button>
        <DialogComponent id="dialog" width='300px' isModal={true} target='#container' header='Sign In' close={this.onClose} open={this.onOpen} buttons={this.buttons} ref={dialog => this.dialogObj = dialog}>
          <div className='form-group'><label htmlFor='email'>Email:</label>
            <input type='email' className='form-control' id='email' />
          </div>
          <div className='form-group'>
                <label htmlFor='comment'>Password:</label>
                <input type='password' className='form-control' id='password' />
          </div>
         </DialogComponent>
    </div>);
  }
}
export default App;

[Functional-component]

import { DialogComponent } from '@syncfusion/ej2-react-popups';
import * as React from "react";
function App() {
    let dialogInstance;
    const buttons = [{
            buttonModel: {
                content: 'Ok',
                isPrimary: true,
            },
            'click': () => {
                dialogInstance.hide();
            }
        }, {
            buttonModel: {
                content: 'Cancel'
            },
            'click': () => {
                dialogInstance.hide();
            }
        }];
    function dialogContent() {
        return (<><div className='form-group'><label htmlFor='email'>Email:</label>
          <input type='email' className='form-control' id='email'/>
      </div><div className='form-group'>
              <label htmlFor='comment'>Password:</label>
              <input type='password' className='form-control' id='password'/>
          </div></>);
    }
    function onOpen(args) {
        args.preventFocus = true;
    }
    return (<div className="App" id='container'>  
          <DialogComponent id="dlg-focus" width='300px' isModal={true} target='#container' header='Sign In' open={onOpen} buttons={buttons} ref={dialog => dialogInstance = dialog}>
           <div>{dialogContent()}</div>
           </DialogComponent>
      </div>);
}
export default App;
import { DialogComponent } from '@syncfusion/ej2-react-popups';
import * as React from "react";

function App() {
    let dialogObj: DialogComponent;
    let buttonElement: HTMLElement;
    let buttonRef: React.Ref<HTMLButtonElement> = (element) => {
        buttonElement = element;
    };
    const buttons: any = [{
      buttonModel: {
          content: 'Ok',
          isPrimary: true,
      },
      'click': () => {
          dialogObj.hide();
      }
    }, {
      buttonModel: {
          content: 'Cancel'
      },
      'click': () => {
          dialogObj.hide();
      }
    }];

    function onOpen (args: any): void {
        args.preventFocus = true;
    }

    function onOpenDialog() {
        dialogObj.show();
        buttonElement.style.display = 'none';
    };

    function onClose(){
        buttonElement.style.display = 'block';
    }

    return (
      <div className="App" id='container'>
        <button className="e-control e-btn" style= ref={buttonRef} onClick={onOpenDialog.bind(this)}>Open dialog</button> 
          <DialogComponent id="dialog" close={onClose} width='300px' isModal={true} target='#container' header='Sign In' open={onOpen} buttons={buttons} ref={dialog => dialogObj = dialog}>
            <div className='form-group'><label htmlFor='email'>Email:</label>
                <input type='email' className='form-control' id='email' />
            </div>
            <div className='form-group'>
              <label htmlFor='comment'>Password:</label>
              <input type='password' className='form-control' id='password' />
            </div>
           </DialogComponent>
      </div>
    );
}
export default App;

## See Also

Prevent the focus on the first element in Vue Dialog component

30 Aug 20258 minutes to read

By default, the dialog focuses on the first elements of the content area which can be active and focusable. You can prevent this default focusing behavior using the open event and by enabling the preventFocus argument.

Bind the open event and enable the preventFocus argument within an event like the below sample.

<template>
    <div>
        <div id="dialogTarget" class="control-section; position:relative" style="height:300px;">
            <!-- Render Button to open the Dialog -->
            <ejs-button id='dlgbtn' v-on:click="dialogBtnClick">Open Dialog</ejs-button>
            <!-- Render Dialog -->
            <ejs-dialog id="dialog" ref="Dialog" :header='header' :target='target' :width='width' :buttons='buttons'
                :open="onOpen">
                <div class='form-group'><label for='email'>Email:</label>
                    <input type='email' class='form-control' id='email'>
                </div>
                <div class='form-group'>
                    <label for='comment'>Password:</label>
                    <input type='password' class='form-control' id='password'>
                </div>
            </ejs-dialog>
        </div>
    </div>
</template>
<script setup>
import { DialogComponent as EjsDialog } from '@syncfusion/ej2-vue-popups';
import { ButtonComponent as EjsButton } from '@syncfusion/ej2-vue-buttons';
import { ref } from 'vue';

const Dialog = ref(null);
const target = "#dialogTarget";
const width = '300px';
const header = 'Sign In';

const dialogBtnClick = () => {
    Dialog.value.show();
};
const dlgButtonClick = () => {
    Dialog.value.hide();
};
const onOpen = (args) => {
    args.preventFocus = true;
};
const buttons = [{ click: dlgButtonClick, buttonModel: { content: 'Ok', isPrimary: true } }, { click: dlgButtonClick, buttonModel: { content: 'Cancel' } }]

</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-popups/styles/material.css";

#app {
    color: #008cff;
    height: 40px;
    left: 45%;
    position: absolute;
    top: 45%;
    width: 30%;
}

.control-section {
    height: 100%;
    min-height: 200px;
}
</style>
<template>
    <div>
        <div id="dialogTarget" class="control-section; position:relative" style="height:300px;">
            <!-- Render Button to open the Dialog -->
            <ejs-button id='dlgbtn' v-on:click="dialogBtnClick">Open Dialog</ejs-button>
            <!-- Render Dialog -->
            <ejs-dialog id="dialog" ref="Dialog" :header='header' :target='target' :width='width' :buttons='buttons'
                :open="onOpen">
                <div class='form-group'><label for='email'>Email:</label>
                    <input type='email' class='form-control' id='email'>
                </div>
                <div class='form-group'>
                    <label for='comment'>Password:</label>
                    <input type='password' class='form-control' id='password'>
                </div>
            </ejs-dialog>
        </div>
    </div>
</template>
<script>
import { DialogComponent } from '@syncfusion/ej2-vue-popups';
import { ButtonComponent } from '@syncfusion/ej2-vue-buttons';

export default {
    name: "App",
    components: {
        "ejs-button": ButtonComponent,
        "ejs-dialog": DialogComponent
    },
    data: function () {
        return {
            target: "#dialogTarget",
            width: '300px',
            header: 'Sign In',
            buttons: [{ click: this.dlgButtonClick, buttonModel: { content: 'Ok', isPrimary: true } }, { click: this.dlgButtonClick, buttonModel: { content: 'Cancel' } }]
        }
    },
    methods: {
        dialogBtnClick: function () {
            this.$refs.Dialog.show();
        },
        dlgButtonClick: function () {
            this.$refs.Dialog.hide();
        },
        onOpen: function (args) {
            args.preventFocus = true;
        }
    }
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-popups/styles/material.css";

#app {
    color: #008cff;
    height: 40px;
    left: 45%;
    position: absolute;
    top: 45%;
    width: 30%;
}

.control-section {
    height: 100%;
    min-height: 200px;
}
</style>

See Also